/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#include "useelement.h"

// Elements
#include "urireference.h"

// Visitors
#include "visitors/visitor.h"

UseElement::UseElement()
    : GroupElement()
{
  m_ref = new URIReference(this);
}


UseElement::~UseElement()
{}


UseElement::UseElement( const UseElement &other )
    : GroupElement()
{
  m_ref = new URIReference(this);
  (*this) = other;
}

UseElement& UseElement::operator=(const UseElement &other)
{
  GroupElement::operator=(other);
  *m_ref = other.ref();
  return *this;
}

ElementNode* UseElement::clone()
{
  UseElement* retElem = new UseElement();
  *retElem = *this;
  return ( retElem );
}

void UseElement::accept( Visitor& visitor )
{
  visitor.visit( *this );
}

Attribute* UseElement::getAttrByName( const QString & name )
{
  return GroupElement::getAttrByName(name);
}

Element::Hit UseElement::hits( const QPoint &p )
{
  Element::Hit retHit = Element::NOHIT;

//   KCanvasItem *canvasItem;
//   for ( canvasItem = m_contextList.first(); canvasItem; canvasItem = m_contextList.next() )
//     if ( canvasItem )
//     {
//       if ( canvasItem->strokeContains(p) )
//       {
//         if ( retHit != Element::FILLHIT )
//           retHit = Element::PATHHIT;
//       }
//       else if ( canvasItem->fillContains(p) )
//         retHit = Element::FILLHIT;
//     }
  return retHit;
}

QRect UseElement::bbox( KCBBoxFlags flags ) const
{
  QRect retRect = QRect();

//   KCanvasItem *canvasItem;
//   for ( canvasItem = m_contextList.first(); canvasItem; canvasItem = m_contextList.next() )
//     if ( canvasItem )
//       retRect.unite(canvasItem->bbox(flags));

  return retRect;
}

#include "useelement.moc"
